<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Ventrilo Viewer Infusion                    
| Filename: ventrilo_admin.php
| Author: Michal "An_Old_Man" Thomsen          
| Author: Peter "Van_Dragen" Nielsen           
| web: http://www.99.dk                       
| web: http://www.vandragen.dk                
| email: admin@99.dk                          
| email: admin@vandragen.dk                   
|--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/


//require_once "../../maincore.php";
//require_once BASEDIR."subheader.php";
//require_once ADMIN."navigation.php";

require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";

require_once INFUSIONS."ventrilo_panel/infusion_db.php";

error_reporting(E_ALL);
ini_set('display_errors', false);
ini_set('html_errors', true);

$feedtest 	= "";
$feedok 	= "No feed";
$info_lev   	= "#key#";

//if (!checkrights("XXX") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../index.php"); }
if (!checkrights("IP")) fallback("../index.php");

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."ventrilo_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."ventrilo_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."ventrilo_panel/locale/English.php";
}

//--- Save ventrilo viewer settings
if (isset($_POST['savesettings'])) {
  $result = dbquery("UPDATE ".DB_VENTRILO_TABLE." SET ".
	  "server_ip  ='".$_POST['serverip'] ."', ".
          "feed_on ='".$_POST['feedon']."', ".
          "feed_ip ='".$_POST['feedip']."', ".
	  "query_port ='".$_POST['queryport']."', ".
          "info_ping ='".$_POST['infoping']."', ".
          "info_admin ='".$_POST['infoadmin']."', ".
          "info_time ='".$_POST['infotime']."', ".
	  "info_comm ='".$_POST['infocomm']."' ,".
	  "compatible ='".$_POST['compatible']."' where ventrilo_Id ='1'");
          
  header("Location: ventrilo_admin.php");
}

//--- Insert first Configurationrecord if not exists
$result = dbquery("SELECT ventrilo_id FROM ".DB_VENTRILO_TABLE." WHERE ventrilo_id ='1'");
if (dbrows($result) == 0) {
  $result = dbquery("INSERT INTO ".DB_VENTRILO_TABLE." (ventrilo_id) VALUES('1')");
}

// Test Feed

$data = dbarray(dbquery("SELECT * FROM ".DB_VENTRILO_TABLE." WHERE ventrilo_id ='1'"));
$feed_url   = $data['feed_ip'];
$feedok     = $data['feed_on'];

If ($feedok=="0") $feedok="";
If ($feedok=="1") {
	ob_start();
	readfile("http://".$feed_url."/ventrilo_feed.php");
	$imdata = ob_get_contents();
	ob_end_clean();
	$vdata = explode($info_lev, $imdata); 
	$feedtest =  explode (":",$vdata[0]);
	if ( $feedtest[0] == "NAME" ) {
		$feedok = $locale['VNT112']; 
		$feedname = $feedtest[1];
	} else { $feedok = $locale['VNT113']; }
}

//--- Read ventrilo viewer settings
$vnt_settings = dbarray(dbquery("SELECT * FROM ".DB_VENTRILO_TABLE." WHERE ventrilo_id ='1'"));

opentable($locale['VNT100']);
echo "<form name='vntsettingsform' method='post' action='".FUSION_SELF."'>
        <table width='700' align='center' cellspacing='0' cellpadding='0' class='tbl'>
          <tr>
            <td>
              <table width='100%' cellspacing='0' cellpadding='0' class='tbl'>
                <tr>
		<tr>
		<td width='40%'>".$locale['VNT102']."</td>
                  <td width='60%'><input type='text' name='serverip' value='".$vnt_settings['server_ip']."' maxlength='30' class='textbox'></td>
                </tr>
                <tr>
                  <td width='40%'>".$locale['VNT103']."</td>
                  <td width='60%'><input type='text' name='queryport' value='".$vnt_settings['query_port']."' maxlength='10' class='textbox'></td>
                </tr>
		<tr>
		  <td width='40%'>".$locale['VNT105']."</td>
  	          <td width='60%'><input type='checkbox' name='infoping' class='textbox' value='1' ";
		if ($vnt_settings['info_ping']) {
			echo "checked";
		}
		echo "></td><tr>
		  <td width='40%'>".$locale['VNT106']."</td>
  	          <td width='60%'><input type='checkbox' name='infoadmin' class='textbox' value='1' ";
		if ($vnt_settings['info_admin']) {
			echo "checked";
		}
		echo "></tr></td><tr>
		  <td width='40%'>".$locale['VNT107']."</td>
  	          <td width='60%'><input type='checkbox' name='infotime' class='textbox' value='1' ";
		if ($vnt_settings['info_time']) {
			echo "checked";
		}
                echo "></tr></td><tr>
		  <td width='40%'>".$locale['VNT108']."</td>
  	          <td width='60%'><input type='checkbox' name='infocomm' class='textbox' value='1' ";
		if ($vnt_settings['info_comm']) {
			echo "checked";
		}
                echo "></tr></td><tr>
		  <td width='40%'>".$locale['VNT114']."</td>
  	          <td width='60%'><input type='checkbox' name='compatible' class='textbox' value='1' ";
		if ($vnt_settings['compatible']) {
			echo "checked";
		}		
		echo "></td>
			</tr>
			</table>
			<table width='100%' cellspacing='0' cellpadding='0' class='tbl'>
			<tr>------------------------------------------------------------</tr>
			<tr>
		  <td width='40%'>".$locale['VNT110']."</td>
  	          <td width='60%'><input type='checkbox' name='feedon' class='textbox' value='1' ";
		if ($vnt_settings['feed_on']) {
			echo "checked";
		}
		echo "></td><tr>
                  <td width='40%'>".$locale['VNT111']."</td>
                  <td width='60%'>http://<input type='text' name='feedip' value='".$vnt_settings['feed_ip']."' size='40' maxlength='40' class='textbox'>/ventrilo_feed.php<br>".$feedok.$feedname."</b> </td>
                </tr>
		</table>
            </td>
          </tr>
          <tr>
            <td align='center'><br><input type='submit' name='savesettings' value='".$locale['VNT109']."' class='button'></td>
          </tr>
        </table>
      </form>";

closetable();

//echo "</td>\n";
//require_once BASEDIR."footer.php";
require_once THEMES."templates/footer.php";
?>
