<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Ventrilo Viewer Infusion                    
| Filename: infusion.php
| Author: Michal "An_Old_Man" Thomsen          
| Author: Peter "Van_Dragen" Nielsen           
| web: http://www.99.dk                       
| web: http://www.vandragen.dk                
| email: admin@99.dk                          
| email: admin@vandragen.dk                   
|--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/

//if (!defined("IN_FUSION") || !checkrights("I")) { die("Access Denied"); }
if (!checkrights("IP") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../index.php"); }

require_once INFUSIONS."ventrilo_panel/infusion_db.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."ventrilo_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."ventrilo_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."ventrilo_panel/locale/English.php";
}

// Infusion general information
$inf_title       = $locale['VNT100'];
$inf_description = $locale['VNT101'];
$inf_version     = "2.0";
$inf_developer   = "An_Old_Man & Van_Dragen";
$inf_email       = "admin@99.dk";
$inf_weburl      = "http://www.99.dk";
$inf_folder      = "ventrilo_panel";

// Infusion Paths

//$inf_admin_panel = "ventrilo_admin.php";
//$inf_admin_image = "vent.gif";    // Leave blank to use the default image.


//$inf_link_name       = "Ventrilo View";
//$inf_link_url        = "ventrilo_page.php";  // The filename you wish to link to.
//$inf_link_visibility = "101"; // 0 - Guest / 101 - Member / 102 - Admin / 103 - Super Admin.

$inf_newtables   = 1; // Number of new db tables to create or drop.
$inf_altertables = 0; // Number of db tables to alter (upgrade).
$inf_deldbrows   = 0; // Number of db tables to delete data from.

$inf_newtable[1] = DB_VENTRILO_TABLE." (
  ventrilo_id SMALLINT(7) NOT NULL AUTO_INCREMENT,
  server_ip VARCHAR(30) NOT NULL,
  feed_on SMALLINT(1) NOT NULL,
  feed_ip VARCHAR(40) NOT NULL,
  query_port VARCHAR(10) NOT NULL,
  info_ping SMALLINT(1) NOT NULL,
  info_admin SMALLINT(1) NOT NULL,
  info_time SMALLINT(1) NOT NULL,
  info_comm SMALLINT(1) NOT NULL,
 compatible SMALLINT(1) NOT NULL,
  PRIMARY KEY (ventrilo_id)
) TYPE=MyISAM;";

$inf_insertdbrow[1] = DB_VENTRILO_TABLE." (ventrilo_id, server_ip, feed_on, feed_ip, query_port, info_ping, info_admin, info_time, info_comm, compatible) VALUES('', '', '', '', '', '', '', '', '')";
$inf_droptable[1] = DB_VENTRILO_TABLE;
$inf_altertable[1] = ""; //DB_VENTRILO_TABLE;
$inf_deldbrow[1] = ""; //DB_VENTRILO_TABLE;

$inf_adminpanel[1] = array(
	"title" => $locale['VNT100'],
	"image" => "vent.gif",
	"panel" => "ventrilo_admin.php",
	"rights" => "XXX"
);
/*
	title - the name of the link shown in the infusions admin panel.
	image - the image displayd in the infusions admin panel.
	link - the name of the admin panel file.
	rights - v7 infusions must have a unique access rights value, can be up to 4 letters (uppercase only).
*/

$inf_sitelink[1] = array(
	"title" => $locale['VNT301'],
	"url" => "ventrilo_page.php",
	"visibility" => "101"
);
/*
title - the name of the link shown in the navigation menu.
url - the name of the infusion panel file.
visibility - defines visibility (0, 101, 102 or 103).
*/

?>
